searchData={"items":[{"type":"extras","title":"Generic BeagleBone Support","doc":"# Generic BeagleBone Support\n\n[![CircleCI](https://circleci.com/gh/nerves-project/nerves_system_bbb.svg?style=svg)](https://circleci.com/gh/nerves-project/nerves_system_bbb)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_system_bbb.svg \"Hex version\")](https://hex.pm/packages/nerves_system_bbb)\n\nThis is the base Nerves System configuration for the [BeagleBone Black](http://beagleboard.org/black),\n[BeagleBone Green](http://beagleboard.org/green), [BeagleBone Green Wireless](https://beagleboard.org/green-wireless/),\nand [PocketBeagle](https://beagleboard.org/pocket).\n\n![BeagleBone Black image](assets/images/beaglebone-black.png)\n  [Image credit](#fritzing) \n\n| Feature              | Description                     |\n| -------------------- | ------------------------------- |\n| CPU                  | 1 GHz ARM Cortex-A8             |\n| Memory               | 512 MB DRAM                     |\n| Storage              | 4 GB eMMC Flash and MicroSD     |\n| Linux kernel         | 5.10 w/ BBB patches             |\n| IEx terminal         | UART `ttyS0`                    |\n| GPIO, I2C, SPI       | Yes - [Elixir Circuits](https://github.com/elixir-circuits) |\n| ADC                  | Yes                             |\n| PWM                  | Yes, but no Elixir support      |\n| UART                 | ttyS0 + more via device tree overlay |\n| Camera               | None                            |\n| Ethernet             | Yes                             |\n| WiFi                 | Beaglebone Green Wireless (wl18xx driver). Other requires USB WiFi dongle/driver |\n| HW Watchdog          | AM335x watchdog enabled on boot. Be sure to enable `heart` in your vm.args or the device will reboot |","ref":"readme.html"},{"type":"extras","title":"Using - Generic BeagleBone Support","doc":"The most common way of using this Nerves System is create a project with `mix\nnerves.new` and to export `MIX_TARGET=bbb`. See the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/customizing-systems.html).","ref":"readme.html#using"},{"type":"extras","title":"Preparing your BeagleBone - Generic BeagleBone Support","doc":"If your BeagleBone has eMMC (the PocketBeagle doesn't), it will be configured to\ntry the eMMC first when looking for software on boot. If you haven't\nreprogrammed it, it will boot to Debian even if a MicroSD card is inserted with\ngood software. To boot from the MicroSD card, hold down the USER button and\napply power.\n\nWhen starting with Nerves, you will find that booting from a MicroSD card is\nconvenient since you can easily recover from broken software images. Holding\ndown the USER button will get old. To force the BeagleBone to boot from the\nMicroSD card, simply corrupt the image on the eMMC memory.  Don't worry, the\nBeagleBone website has instructions for restoring Debian.\n\nFrom Debian:\n\n```bash\ndebian@beaglebone:~$ sudo dd if=/dev/zero of=/dev/mmcblk0 bs=1M count=100\n100+0 records in\n100+0 records out\n104857600 bytes (105 MB) copied, 5.72098 s, 18.3 MB/s\ndebian@beaglebone:~$ sudo reboot\n```\n\nWhen it reboots, it will boot from the MicroSD slot. If a MicroSD card hasn't\nbeen inserted or if there are errors reading it, you will see the letter `C`\nprinted repeatedly on the console port.","ref":"readme.html#preparing-your-beaglebone"},{"type":"extras","title":"Console access - Generic BeagleBone Support","doc":"The console is configured to output to the 6 pin header on the\nBeagleBone that's labeled J1. A 3.3V FTDI cable is needed to access the output.\n\nThe HDMI output has been disabled via device tree to free up pins on the GPIO\nheader. If you would like console access via HDMI, you will need to enable HDMI\nsupport in the Linux kernel, remove the HDMI disable argument in the uboot\nscript providing kernel arguments, and change `erlinit.conf` to output to\n`tty1`.","ref":"readme.html#console-access"},{"type":"extras","title":"Provisioning devices - Generic BeagleBone Support","doc":"This system supports storing provisioning information in a small key-value store\noutside of any filesystem. Provisioning is an optional step and reasonable\ndefaults are provided if this is missing.\n\nProvisioning information can be queried using the Nerves.Runtime KV store's\n[`Nerves.Runtime.KV.get/1`](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.KV.html#get/1)\nfunction.\n\nKeys used by this system are:\n\nKey                    | Example Value     | Description\n:--------------------- | :---------------- | :----------\n`nerves_serial_number` | `\"12345678\"`       | By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the BBB's serial number.\n\nThe normal procedure would be to set these keys once in manufacturing or before\ndeployment and then leave them alone.\n\nFor example, to provision a serial number on a running device, run the following\nand reboot:\n\n```elixir\niex> cmd(\"fw_setenv nerves_serial_number 12345678\")\n```\n\nThis system supports setting the serial number offline. To do this, set the\n`NERVES_SERIAL_NUMBER` environment variable when burning the firmware. If you're\nprogramming MicroSD cards using `fwup`, the commandline is:\n\n```sh\nsudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw\n```\n\nSerial numbers are stored on the MicroSD card so if the MicroSD card is\nreplaced, the serial number will need to be reprogrammed. The numbers are stored\nin a U-boot environment block. This is a special region that is separate from\nthe application partition so reformatting the application partition will not\nlose the serial number or any other data stored in this block.\n\nAdditional key value pairs can be provisioned by overriding the default\nprovisioning.conf file location by setting the environment variable\n`NERVES_PROVISIONING=/path/to/provisioning.conf`. The default provisioning.conf\nwill set the `nerves_serial_number`, if you override the location to this file,\nyou will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"Linux and U-Boot versions - Generic BeagleBone Support","doc":"The BeagleBone Black has many options for Linux that vary by kernel version and\npatch set. Nerves tracks those maintained by Robert Nelson at\n[eewiki.net](https://eewiki.net/display/linuxonarm/BeagleBone+Black).\n\nNerves also integrates the BeagleBone Black's U-boot patches to support device\ntree overlays. Support mirrors the BeagleBone docs with the exception that to\nset U-boot environment variables, See the section below for more information.","ref":"readme.html#linux-and-u-boot-versions"},{"type":"extras","title":"Device tree overlays - Generic BeagleBone Support","doc":"Most pins on the BBB's headers are configurable via a mechanism called the\ndevice tree. The device tree is made up of device tree files and overlay files\nthat get compiled down into one or more `.dtb` or `.dtbo` files. The files tell\nLinux what drivers to load and what parameters to use for things that it can't\nfigure out by itself.\n\nThere are two strategies for dealing with the device tree:\n\n1. Modify the device tree files for an existing board to make your own\n2. Load device tree overlay files\n\nUpstream BBB encourages the second option since it can be easier. The tradeoff\nis that if anything goes wrong or your hardware doesn't match their assumptions,\nit's a little harder to debug.\n\nThe device tree files are loaded by U-Boot. Nerves installs all of the\nBeagleboard overlay files to `/lib/firmware` and configures U-Boot to closely\nmatch upstream. This means that most of the upstream documentation on device\ntree is usable. The difference is that instead of using `/boot/uEnv.txt` to\ncustomize the overlays, you need to set the variables in the U-Boot environment\nblock. This can be done by running `cmd(\"fw_setenv    \")` from the IEx\nprompt or by adding the variables to the `fwup_include/provisioning.conf` file.\n\nFor example, at the IEx prompt:\n\n```elixir\ncmd(\"fw_setenv uboot_overlay_addr7 /lib/firmware/BB-UART1-00A0.dtbo\")\n```\n\nOr by updating the configuration file:\n\n```\nuboot_setenv(uboot-env, \"uboot_overlay_addr7\", \"/lib/firmware/BB-UART1-00A0.dtbo\")\n```\n\nSee\n[elinux.org/Beagleboard:BeagleBoneBlack_Debian](https://elinux.org/Beagleboard:BeagleBoneBlack_Debian#U-Boot_.2Fboot.2FuEnv.txt_configuration)\nfor documentation on the variables.\n\n#","ref":"readme.html#device-tree-overlays"},{"type":"extras","title":"Universal I/O - Generic BeagleBone Support","doc":"The BBB's Universal device tree overlay lets you configure pins at runtime. This\nsystem enables the universal overlay by default. See the\n`enable_uboot_cape_universal` setting in the default `fwup_include/provisioning.conf` file.\n\nSee\n[beaglebone-universal-io](https://github.com/cdsteinkuehler/beaglebone-universal-io)\nfor documentation. You'll see references to an RCN-built kernel. RCN is the\ninitials for Robert Nelson and we use his kernel patches.\n\n#","ref":"readme.html#universal-i-o"},{"type":"extras","title":"ADCs - Generic BeagleBone Support","doc":"The following example shows how to read values from the 7 ADC inputs in Elixir.\nYou will first need to load \"BB-ADC\" device tree overlay using the guide described\nabove.\n\n```elixir\niex(nerves@nerves-0014.local)> ls \"/sys/bus/iio/devices/iio:device0\"\nbuffer              dev                 in_voltage0_raw     in_voltage1_raw\nin_voltage2_raw     in_voltage3_raw     in_voltage4_raw     in_voltage5_raw\nin_voltage6_raw     name                of_node             power\nscan_elements       subsystem           uevent\niex(nerves@nerves-0014.local)> File.read(\"/sys/bus/iio/devices/iio:device0/in_voltage0_raw\")\n{:ok, \"3891\\n\"}\niex(nerves@nerves-0014.local)> File.read(\"/sys/bus/iio/devices/iio:device0/in_voltage0_raw\")\n{:ok, \"3890\\n\"}\niex(nerves@nerves-0014.local)> File.read(\"/sys/bus/iio/devices/iio:device0/in_voltage0_raw\")\n{:ok, \"3891\\n\"}\n```\n\n#","ref":"readme.html#adcs"},{"type":"extras","title":"SPI - Generic BeagleBone Support","doc":"The following examples shows how to get SPI0 functional in Elixir.\n\nLoad the \"BB-SPIDEV0\" device tree overlay using the guide described above.\n\nVerify that the device drivers are loaded and read spi0 transfers:\n\n```elixir\niex(nerves@nerves-0014.local)> ls \"/dev\"\n  ...\n        spidev1.0              spidev1.1              spidev2.0              spidev2.1\n  ...\niex(nerves@nerves-0014.local)> File.read \"/sys/bus/spi/devices/spi1.0/statistics/transfers\"\n{:ok, \"0\"}\n```\n\nIf you have included [circuits_spi](https://github.com/elixir-circuits/circuits_spi) as a\ndependency, you can start it now and test a transfer:\n\n> The example below should work without any additional hardware connected to the\n> BBB. If you have SPI hardware connected to the BBB, your returned binary might\n> be different.\n\n```elixir\niex(nerves@nerves-0014.local)> {:ok, ref} = Circuits.SPI.open(\"spidev0.0\")\n{:ok, #Reference }\niex(nerves@nerves-0014.local)> Circuits.SPI.transfer(ref,  >)\n >\n```\n\n> Note: If you get back all 0's, then you have likely have not configured the\n> overlay pins correctly.","ref":"readme.html#spi"},{"type":"extras","title":"PRUS - Generic BeagleBone Support","doc":"The PRUs are controlled via `uio`. Two kernel modules are needed for them to work.\n\n```elixir\niex> :os.cmd('modprobe uio uio_pruss')\niex> ls \"/sys/class/uio\"\nuio0     uio1     uio2     uio3     uio4     uio5     uio6     uio7\n```\n\nCheck the beaglebone [am335x_pru_package](https://github.com/beagleboard/am335x_pru_package/)\nrepository for samples on how to interface PRUs.","ref":"readme.html#prus"},{"type":"extras","title":"Supported USB WiFi devices - Generic BeagleBone Support","doc":"The base image includes drivers and firmware for the TI WiLink8 (`wl18xx`),\nRalink RT53xx (`rt2800usb` driver) and RealTek RTL8712U (`r8712u` driver)\ndevices. All WiFi drivers are compiled as modules. Some drivers can be loaded\nautomatically. If you have a Beaglebone Green or Beaglebone Black with built-in\nWiFi, see the next section.\n\nWe are still working out which subset of all possible WiFi dongles to support in\nour images. At some point, we may have the option to support all dongles and\nselectively install modules at packaging time, but until then, these drivers and\ntheir associated firmware blobs add significantly to Nerves release images.\n\nIf you are unsure what driver your WiFi dongle requires, run Raspbian and\nconfigure WiFi for your device. At a shell prompt, run `lsmod` to see which\ndrivers are loaded.  Running `dmesg` may also give a clue. When using `dmesg`,\nreinsert the USB dongle to generate new log messages if you don't see them.","ref":"readme.html#supported-usb-wifi-devices"},{"type":"extras","title":"Bluetooth - Generic BeagleBone Support","doc":"The Beaglebone boards with built-in WiFi support use the WiLink8 WL1835 module.\nThis is a combo WiFi/Bluetooth module. Bluetooth is not well supported in\nNerves. However, Nerves is built on Linux so you can enable and use `bluez`.\nAnother option is to use [harald](https://hex.pm/packages/harald) which can\ncommunicate with the module using low level Bluetooth HCI commands.\n\nThe WL1835 requires initialization before first use. This is done via a \"BTS\"\nfile. The `TIInit_11.8.32.bts` file is included in this system under\n`lib/firmware/ti-connectivity`. The Bluetooth kernel modules know how to load it\nautomatically. If you're using `harald`, you will need to load it yourself. The\nsource of the \"BTS\" file is http://www.ti.com/tool/wl18xx-bt-sp.\n\n[Image credit](#fritzing): This image is from the [Fritzing](http://fritzing.org/home/) parts library.","ref":"readme.html#bluetooth"},{"type":"extras","title":"NervesKey - Generic BeagleBone Support","doc":"Using NervesKey on an I2C bus requires the bus speed to be lowered. This can be\ndone using uboot overlays specific to the I2C bus that NervesKey is attached\nto. The device tree blob can be found in `/lib/firmware`.\n\nChoose one of the following:\n\n```text\nuboot_setenv(uboot-env, \"uboot_overlay_addr4\", \"/lib/firmware/i2c1-clock-frequency-100khz.dtbo\")\nuboot_setenv(uboot-env, \"uboot_overlay_addr5\", \"/lib/firmware/i2c2-clock-frequency-100khz.dtbo\")\n```\n\nYou can configure your project to enable these device tree overlays by copying the\n`fwup_include/provisioning.conf` file to your project, updating the file to\nenable the uboot overlay for your NervesKey i2c bus, and by adding the following\nto your Mix Application configuration:\n\n```elixir\nconfig :nerves, :firmware,\n  provisioning: \"project/relative/path/to/provisioning.conf\"\n```","ref":"readme.html#nerveskey"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThis project does NOT follow semantic versioning. The version increases as\nfollows:\n\n1. Major version updates are breaking updates to the build infrastructure.\n   These should be very rare.\n2. Minor version updates are made for every major Buildroot release. This\n   may also include Erlang/OTP and Linux kernel updates. These are made four\n   times a year shortly after the Buildroot releases.\n3. Patch version updates are made for Buildroot minor releases, Erlang/OTP\n   releases, and Linux kernel updates. They're also made to fix bugs and add\n   features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"v2.19.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Package updates\n  * [nerves_system_br v1.24.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.1)\n  * [Erlang/OTP 26.1.1](https://erlang.org/download/OTP-26.1.1.README)\n  * [Buildroot 2023.05.3](https://lore.kernel.org/buildroot/87h6ngup34.fsf@48ers.dk/T/)","ref":"changelog.html#v2-19-1"},{"type":"extras","title":"v2.19.0 - Changelog","doc":"This is a Buildroot version update that appears to mostly contain bug and\nsecurity fixes. It should be a low risk upgrade from v2.18.2.\n\n* New features\n  * Support factory reset, preventing firmware reverts. See [Nerves.Runtime.FwupOps](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.FwupOps.html)\n\n* Updated dependencies\n  * [nerves_system_br v1.24.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.0)\n  * [Buildroot 2023.05.2](https://lore.kernel.org/buildroot/87ledrkrpp.fsf@48ers.dk/T/), [2023.05.1](https://lore.kernel.org/buildroot/87351m8qm4.fsf@48ers.dk/T/), [2023.05](https://lore.kernel.org/buildroot/87r0qn2c77.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.1](https://erlang.org/download/OTP-26.1.README)","ref":"changelog.html#v2-19-0"},{"type":"extras","title":"v2.18.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.23.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.3)","ref":"changelog.html#v2-18-2"},{"type":"extras","title":"v2.18.1 - Changelog","doc":"This is a bug and security fix update. It should be a low risk upgrade.\n\n* Fixes\n  * Fix CTRL+R over ssh\n\n* Updated dependencies\n  * [nerves_system_br v1.23.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.2)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87y1je6wva.fsf@48ers.dk/T/)","ref":"changelog.html#v2-18-1"},{"type":"extras","title":"v2.18.0 - Changelog","doc":"This is a major update that brings in Erlang/OTP 26, Buildroot 2023.02.2 and\nLinux 5.10.162.\n\n* New features\n  * CA certificates are included for OTP 26.\n\n* Updated dependencies\n  * [nerves_system_br v1.23.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.1)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87wn03ifbl.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.0.2](https://erlang.org/download/OTP-26.0.2.README)\n  * Linux 5.10.162","ref":"changelog.html#v2-18-0"},{"type":"extras","title":"v2.17.2 - Changelog","doc":"This is a bug and security fix update. It should be a low risk upgrade.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.5)\n  * [Buildroot 2022.11.3](https://lore.kernel.org/buildroot/878rfuxbxx.fsf@dell.be.48ers.dk/T/)","ref":"changelog.html#v2-17-2"},{"type":"extras","title":"v2.17.1 - Changelog","doc":"This is a bug fix and Erlang version bump from 25.2 to 25.2.3. It should be a\nlow risk upgrade.\n\n* Fixes\n  * Set Erlang crash dump timer to 5 seconds, so if an Erlang crash dump does\n    happen, it will run for at most 5 seconds. See erlinit.conf.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.3)\n  * [Buildroot 2022.11.1](https://lore.kernel.org/buildroot/87ilh4dvax.fsf@dell.be.48ers.dk/T/#u)","ref":"changelog.html#v2-17-1"},{"type":"extras","title":"v2.17.0 - Changelog","doc":"This is a Buildroot version update that appears to mostly contain bug and\nsecurity fixes. It should be a low risk upgrade.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.1)\n  * [Buildroot 2022.11](http://lists.busybox.net/pipermail/buildroot/2022-December/656980.html)\n  * GCC 12.2","ref":"changelog.html#v2-17-0"},{"type":"extras","title":"v2.16.2 - Changelog","doc":"* Changes\n  * Two Buildroot patch updates and an Erlang minor version update\n  * Nerves Heart v2.0 is now included. Nerves Heart connects the Erlang runtime\n    to a hardware watchdog. v2.0 has numerous updates to improve information\n    that you can get and also has more safeguards to avoid conditions that could\n    cause a device to hang forever.\n\n* Updated dependencies\n  * [nerves_system_br v1.21.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.6)\n  * [Erlang/OTP 25.2](https://erlang.org/download/OTP-25.2.README)\n  * [Buildroot 2022.08.3](https://lore.kernel.org/buildroot/87r0x7z5cw.fsf@dell.be.48ers.dk/T/#u)\n  * [nerves_heart v2.0.2](https://github.com/nerves-project/nerves_heart/releases/tag/v2.0.2)","ref":"changelog.html#v2-16-2"},{"type":"extras","title":"v2.16.1 - Changelog","doc":"* Changes\n  * Reduce first-time Linux kernel download by using tarball source\n\n* Updated dependencies\n  * [nerves_system_br v1.21.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.2)\n  * [Erlang/OTP 25.1.2](https://erlang.org/download/OTP-25.1.2.README)","ref":"changelog.html#v2-16-1"},{"type":"extras","title":"v2.16.0 - Changelog","doc":"* Changes\n  * Support aarch64 Linux builds\n  * Add libdtc to support runtime loading of device tree overlays\n\n* Updated dependencies\n  * [nerves_system_br v1.21.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.1)\n    and also see [nerves_system_br v1.21.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.0)\n  * [Buildroot 2022.08.1](http://lists.busybox.net/pipermail/buildroot/2022-October/652816.html)\n  * [Erlang/OTP 25.1.1](https://erlang.org/download/OTP-25.1.1.README)","ref":"changelog.html#v2-16-0"},{"type":"extras","title":"v2.15.3 - Changelog","doc":"* Fixes\n  * Allow kernel includes for device tree overlays (Thanks @insasec)\n\n* Updated dependencies\n  * [nerves_system_br v1.20.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.20.6)\n  * [Erlang/OTP 25.0.4](https://erlang.org/download/OTP-25.0.4.README)\n  * [Buildroot 2022.05.2](http://lists.busybox.net/pipermail/buildroot/2022-August/650546.html)\n  * Also see [Buildroot 2022.05.1 changes](http://lists.busybox.net/pipermail/buildroot/2022-July/647814.html)","ref":"changelog.html#v2-15-3"},{"type":"extras","title":"v2.15.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.20.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.20.4)\n  * [Erlang/OTP 25.0.3](https://erlang.org/download/OTP-25.0.3.README)","ref":"changelog.html#v2-15-2"},{"type":"extras","title":"v2.15.1 - Changelog","doc":"This release reverts the upgrade to Linux 5.15.44. The Linux kernel is now at\n5.10.120. This fixes an issue where the numbering of `/dev/gpiochipN` changed.\nAll code that identified GPIOs by number broke (pretty much everything using\nCircuits.GPIO).","ref":"changelog.html#v2-15-1"},{"type":"extras","title":"v2.15.0 - Changelog","doc":"This release updates to Buildroot 2022.05, Linux 5.15.44 (from Linux 5.10) and\nuses GCC 11.3 (from GCC 10.3). The Linux kernel upgrade could introduce a\nregression, so please verify hardware-specific functionality in your firmware.\n\n* Updated dependencies\n  * [nerves_system_br v1.20.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.20.3)\n  * [Buildroot 2022.05](http://lists.busybox.net/pipermail/buildroot/2022-June/644349.html)\n  * [Erlang/OTP 25.0.2](https://erlang.org/download/OTP-25.0.2.README)","ref":"changelog.html#v2-15-0"},{"type":"extras","title":"v2.14.0 - Changelog","doc":"This release updates to Buildroot 2022.02.1 and OTP 25.0. While this should be\nan easy update for most projects, many programs have been updated. Please review\nthe changes in the updated dependencies for details.\n\n* Updated dependencies\n  * [nerves_system_br v1.19.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.19.0)\n  * [Buildroot 2022.02.1](http://lists.busybox.net/pipermail/buildroot/2022-April/640712.html). Also see [Buildroot 2022.02](http://lists.busybox.net/pipermail/buildroot/2022-March/638160.html)\n  * [Erlang/OTP 25.0](https://erlang.org/download/OTP-25.0.README)","ref":"changelog.html#v2-14-0"},{"type":"extras","title":"v2.13.4 - Changelog","doc":"* Changes\n  * Fix USB/Ethernet support on the BeagleBone Green Gateway\n  * Fix regression in v2.13.3 for loading device tree overlays\n  * Pull in upstream Linux SquashFS patch to improve file system performance\n\n* Updated dependencies\n  * [nerves_system_br v1.18.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.18.6)\n  * linux 5.10.100","ref":"changelog.html#v2-13-4"},{"type":"extras","title":"v2.13.3 - Changelog","doc":"This is mostly a Buildroot and Erlang bug and security fix release. It should be\na low risk upgrade from the previous release.\n\n* Changes\n  * Update the U-Boot bootloader to the 2021.10 release and pull in latest\n    upstream Beaglebone patch set. This adds support for the BBG Gateway. Since\n    the bootloader isn't normally updated, you'll need to re-flash the MicroSD\n    card to get this update. If your device already works, then there's no\n    reason to do this.\n\n* Updated dependencies\n  * [nerves_system_br v1.18.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.18.5)\n  * U-Boot 2021.10","ref":"changelog.html#v2-13-3"},{"type":"extras","title":"v2.13.2 - Changelog","doc":"This is a Buildroot and Erlang bug fix release that also adds support for\nadditional AM335x-based boards. It should be a low risk upgrade from the\nprevious release.\n\n* Updated dependencies\n  * [nerves_system_br v1.18.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.18.4)\n  * Linux 5.10.87\n\n* Changes\n  * Support the Beaglebone Blue (robotics-focused Beaglebone) and the AM3358 EVM\n    Starter Kit (dual Ethernet)\n  * Adjust PRU parameters to match TI configs. If you're using the PRUs, please\n    verify that the changes do not break your code.\n  * Reduce kernel timers from 250 Hz to 100 Hz resolution. 100 Hz is the value\n    used by the TI source and the value used by other official Nerves systems.\n  * When deriving the board serial number, fail back to the `/proc/cpuinfo`\n    contents before using the wired Ethernet MAC.\n  * Specify CPU-specific flags when compiling NIFs and ports. This fixes an\n    issue where some optimizations could not be enabled in NIFs even though it\n    should be possible to have them. E.g., ARM NEON support for CPUs that have\n    it.\n  * Build the Wireguard kernel driver. This is a small device driver that\n    enables a number of VPN-based use cases.","ref":"changelog.html#v2-13-2"},{"type":"extras","title":"v2.13.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.18.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.18.3)\n\n* Changes\n  * Programs that use OpenMP will run now. The OpenMP shared library\n    (`libgomp.so`) was supplied by the toolchain, but not copied.","ref":"changelog.html#v2-13-1"},{"type":"extras","title":"v2.13.0 - Changelog","doc":"This release updates to Buildroot 2021.11, OTP 24.2, and Linux 5.10.64. If you\nhave made a custom system, please review the `nerves_system_br` [release\nnotes](https://github.com/nerves-project/nerves_system_br/blob/v1.18.2/CHANGELOG.md#v1180).\nAlso, the previous release used Linux 5.4, so double check your Linux\nconfiguration to make sure that the update to Linux 5.10.64 doesn't disable\nsomething unexpected.\n\n* Updated dependencies\n  * [nerves_system_br v1.18.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.18.2)\n  * [Buildroot 2021.11](http://lists.busybox.net/pipermail/buildroot/2021-December/629911.html)\n  * [Erlang/OTP 24.2](https://erlang.org/download/OTP-24.2.README)\n  * Linux 5.10.65 with RCN's TI patches. This formerly was the Beagleboard org's\n    patch set. This should not affect most users.\n  * GCC 10.3\n\n* Improvements\n  * Support for the `dl.nerves-project.org` backup site. Due to a GitHub outage\n    in November, there was a 2 day period of failing builds since some packages\n    could not be downloaded. We implemented the backup site to prevent this in\n    the future. This update is in the `nerves_defconfig`.\n  * Use new build ORB on CircleCI. This ORB will shorten build times to fit in\n    CircleCI's new free tier limits. Please update if building your own systems.","ref":"changelog.html#v2-13-0"},{"type":"extras","title":"v2.12.3 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.17.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.17.4)\n  * [Buildroot 2021.08.2](http://lists.busybox.net/pipermail/buildroot/2021-November/628323.html)\n  * [Erlang/OTP 24.1.7](https://erlang.org/download/OTP-24.1.7.README).","ref":"changelog.html#v2-12-3"},{"type":"extras","title":"v2.12.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.17.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.17.3)\n  * [Erlang/OTP 24.1.4](https://erlang.org/download/OTP-24.1.4.README).","ref":"changelog.html#v2-12-2"},{"type":"extras","title":"v2.12.1 - Changelog","doc":"This is a security/bug fix patch release. It should be safe to update for\neveryone.\n\n* Updated dependencies\n  * [nerves_system_br v1.17.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.17.1)\n  * [Buildroot 2021.08.1](http://lists.busybox.net/pipermail/buildroot/2021-October/625642.html)\n  * [Erlang/OTP 24.1.2](https://erlang.org/download/OTP-24.1.2.README)\n\n* Improvements\n  * Include software versioning and licensing info (see legal-info directory in\n    artifact)","ref":"changelog.html#v2-12-1"},{"type":"extras","title":"v2.12.0 - Changelog","doc":"This release updates to Buildroot 2021.08 and OTP 24.1. If you have made a\ncustom system off this one, please review the `nerves_system_br v1.17.0` release\nnotes.\n* Updated dependencies\n  * [nerves_system_br v1.17.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.17.0)\n  * [Buildroot 2021.08](http://lists.busybox.net/pipermail/buildroot/2021-September/622072.html)\n  * [Erlang/OTP 24.1](https://erlang.org/download/OTP-24.1.README)","ref":"changelog.html#v2-12-0"},{"type":"extras","title":"v2.11.2 - Changelog","doc":"This release updates Erlang/OTP from 24.0.3 to 24.0.5 and Buildroot from 2021.05\nto 2021.05.1. Both of these are security/bug fix updates. This is expected to be\na safe upgrade from v1.16.1 for all users.\n\n* Updated dependencies\n  * [nerves_system_br v1.16.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.16.1)\n  * [Erlang/OTP 24.0.5](https://erlang.org/download/OTP-24.0.5.README)\n\n* Improvements\n  * Beta support for using a `runtime.exs` script for runtime configuration.\n  * Added a `provision` task to the `fwup.config` to enable re-provisioning a\n    MicroSD card without changing its contents.\n  * Adds a default `/etc/sysctl.conf` that enables use of ICMP in Erlang. This\n    requires `nerves_runtime v0.11.5` or later to automatically load the sysctl\n    variables. With it using `:gen_udp` to send/receive ICMP will \"just work\".\n    It also makes it easier to add other sysctl variables if needed.","ref":"changelog.html#v2-11-2"},{"type":"extras","title":"v2.11.1 - Changelog","doc":"This release updates Nerves Toolchains to v1.4.3 and OTP 24.0.3. It should be safe for everyone to apply.\n\n* Updated dependencies\n  * [nerves_system_br v1.16.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.16.1)\n  * [Erlang/OTP 24.0.3](https://erlang.org/download/OTP-24.0.3.README)\n  * [nerves toolchains v1.4.3](https://github.com/nerves-project/toolchains/releases/tag/v1.4.3)\n* Improvements\n  * bborg-overlays: bump to latest SHA (device tree updates for BBB)","ref":"changelog.html#v2-11-1"},{"type":"extras","title":"v2.11.0 - Changelog","doc":"This release updates to Buildroot 2021.05 and OTP 24.0.2. If you have made a\ncustom system off this one, please review the `nerves_system_br v1.16.0` release\nnotes.\n\n* Updated dependencies\n  * [nerves_system_br v1.16.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.16.0)\n  * [Buildroot 2021.05](http://lists.busybox.net/pipermail/buildroot/2021-June/311946.html)\n  * [Erlang/OTP 24.0.2](https://erlang.org/download/OTP-24.0.2.README)\n\n* Improvements\n  * This release now contains debug symbols and includes the Build-ID in the\n    ELF headers. This makes it easier to get stack traces from C programs. As\n    before, the Nerves tooling strips all symbols from firmware images, so this\n    won't make programs bigger.\n  * Enable compile-time `wpa_supplicant` options to support WPA3, mesh\n    networking, WPS and autoscan.","ref":"changelog.html#v2-11-0"},{"type":"extras","title":"v2.10.1 - Changelog","doc":"This is a security/bug fix release that updates to Buildroot 2021.02.1 and OTP\n23.3.1. It should be safe for everyone to apply.\n\n* Updated dependencies\n  * [nerves_system_br v1.15.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.15.1)\n  * [Buildroot 2021.02](http://lists.busybox.net/pipermail/buildroot/2021-April/307970.html)\n  * [Erlang/OTP 23.3.1](https://erlang.org/download/OTP-23.3.1.README)","ref":"changelog.html#v2-10-1"},{"type":"extras","title":"v2.10.0 - Changelog","doc":"This release updates to Buildroot 2021.02 and OTP 23.2.7. If you have made a\ncustom system off this one, please review the `nerves_system_br v1.15.0` release\nnotes.\n\nThe Nerves toolchain has also been updated to v1.4.2. This brings in Linux 4.14\nheaders to enable use of cdev and eBPF. This won't affect most users.\n\n* Updated dependencies\n  * [nerves_system_br v1.15.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.15.0)\n  * [Buildroot 2021.02](http://lists.busybox.net/pipermail/buildroot/2021-March/305168.html)\n  * [Erlang/OTP 23.2.7](https://erlang.org/download/OTP-23.2.7.README)\n  * [nerves toolchains v1.4.2](https://github.com/nerves-project/toolchains/releases/tag/v1.4.2)","ref":"changelog.html#v2-10-0"},{"type":"extras","title":"v2.9.0 - Changelog","doc":"This release updates to Buildroot 2020.11.2, GCC 10.2 and OTP 23.2.4.\n\nWhen migrating custom systems based, please be aware of the following important\nchanges:\n\n* There's a new `getrandom` syscall that is made early in BEAM startup. This has\n  the potential to block the BEAM before Nerves can start `rngd` to provide\n  entropy. We have not seen this issue here, but have updated `erlinit.config`\n  for the time being as a precaution.\n* The GCC 10.2.0 toolchain has a different name that calls out \"nerves\" as the\n  vendor and the naming is now more consistent with other toolchain providers.\n* Experimental support for tooling that requires more information about the\n  target has been added. The initial support focuses on zigler.\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.14.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.14.4)\n  * [Buildroot 2020.11.2](http://lists.busybox.net/pipermail/buildroot/2021-January/302574.html)\n  * [Erlang/OTP 23.2.4](https://erlang.org/download/OTP-23.2.4.README)\n  * [Nerves toolchains 1.4.1](https://github.com/nerves-project/toolchains/releases/tag/v1.4.1)","ref":"changelog.html#v2-9-0"},{"type":"extras","title":"v2.8.3 - Changelog","doc":"This is a bug fix release with no major changes.\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.13.7](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.13.7)\n  * [Erlang/OTP 23.1.5](https://erlang.org/download/OTP-23.1.5.README)","ref":"changelog.html#v2-8-3"},{"type":"extras","title":"v2.8.2 - Changelog","doc":"This release includes a patch release update to [Buildroot\n2020.08.2](http://lists.busybox.net/pipermail/buildroot/2020-November/296830.html).\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.13.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.13.5)\n  * [erlinit 1.9.0](https://github.com/nerves-project/erlinit/releases/tag/v1.9.0)","ref":"changelog.html#v2-8-2"},{"type":"extras","title":"v2.8.1 - Changelog","doc":"The main change in this release is to bump the Linux kernel to 5.4.\nIf you have based a custom system off of this one, please inspect the\n`linux-5.4.defconfig` for changes. There were only a few changes, but\nif you are modifying the kernel configuration, please review first.\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.13.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.13.4)\n  * [Erlang/OTP 23.1.4](https://erlang.org/download/OTP-23.1.4.README)\n  * [boardid 1.10.0](https://github.com/nerves-project/boardid/releases/tag/v1.10.0)\n\n* Improvements\n  * Enabled reproducible builds in Buildroot to remove some timestamp and build\n    path differences in firmware images. This helps delta firmware updates.","ref":"changelog.html#v2-8-1"},{"type":"extras","title":"v2.8.0 - Changelog","doc":"This release updates to [Buildroot\n2020.08](http://lists.busybox.net/pipermail/buildroot/2020-September/290797.html) and OTP 23.1.1.\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.13.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.13.2)\n  * [Erlang/OTP 23.1.1](https://erlang.org/download/OTP-23.1.1.README)\n  * [erlinit 1.8.0](https://github.com/nerves-project/erlinit/releases/tag/v1.8.0)\n  * [nerves 1.7.0](https://github.com/nerves-project/nerves/releases/tag/v1.7.0)\n\n* New features\n  * Added support for updating the root filesystem using firmware patches.\n    See the [firmware patch docs](https://hexdocs.pm/nerves/experimental-features.html#content) for more information.","ref":"changelog.html#v2-8-0"},{"type":"extras","title":"v2.7.2 - Changelog","doc":"This release updates to [Buildroot\n2020.05.1](http://lists.busybox.net/pipermail/buildroot/2020-July/287824.html)\nand OTP 23.0.3 which are both bug fix releases.\n\n* Updated dependencies\n  * [nerves_system_br: bump to v1.12.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.12.4)\n  * [Erlang/OTP 23.0.3](https://erlang.org/download/OTP-23.0.3.README)\n  * [nerves_heart v0.3.0](https://github.com/nerves-project/nerves_heart/releases/tag/v0.3.0)\n\n* New features\n  * The `/data` directory now exists for storing application-specific data. It\n    is currently a symlink to `/root`. Using `/data` will eventually be\n    encouraged over `/root` even though currently there is no advantage. This\n    change makes it possible to start migrating paths in applications and\n    libraries.\n\n* Fixes\n  * Fixed old references to the `-Os` compiler flag. All C/C++ code will default\n    to using `-O2` now.","ref":"changelog.html#v2-7-2"},{"type":"extras","title":"v2.7.1 - Changelog","doc":"* Fixes\n  * Remove `nerves_system_linter` from hex package. This fixes mix dependency\n    errors in projects that reference systems with different\n    `nerves_system_linter` dependency specs.","ref":"changelog.html#v2-7-1"},{"type":"extras","title":"v2.7.0 - Changelog","doc":"This release updates the system to use Buildroot 2020.05 and Erlang/OTP 23.\nPlease see the respective release notes for updates and deprecations in both\nprojects for changes that may affect your application.\n\n* New features\n  * Enable WiFi mesh support in the 802.11 stack\n  * NervesKey support (see README.md for device tree overlay information)\n\n* Updated dependencies\n  * [nerves_system_br v1.12.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.12.0)\n  * [Erlang/OTP 23.0.2](https://erlang.org/download/OTP-23.0.2.README)\n  * Linux 4.19.120 with Beagleboard kernel patches","ref":"changelog.html#v2-7-0"},{"type":"extras","title":"v2.6.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.11.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.11.4)\n  * Erlang 22.3.4.1\n  * fwup 1.7.0","ref":"changelog.html#v2-6-2"},{"type":"extras","title":"v2.6.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.11.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.11.2)\n  * Erlang 22.3.1\n  * erlinit 1.7.0 - tty initialization support\n  * fwup 1.6.0 - xdelta3/VCDIFF patch support\n  * Enable unixodbc so that Erlang's odbc application can be used in projects","ref":"changelog.html#v2-6-1"},{"type":"extras","title":"v2.6.0 - Changelog","doc":"This release updates Buildroot to 2020.02 and upgrades gcc from 8.3 to 9.2.\nWhile this is a minor version bump due to the Buildroot release update, barring\nadvanced usage of Nerves, this is a straightforward update from v2.5.2.\n\n* Updated dependencies\n  * [nerves_system_br v1.11.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.11.0)\n  * linux 4.19.103 with Beagleboard kernel patches(bone40)\n  * Erlang 22.2.8","ref":"changelog.html#v2-6-0"},{"type":"extras","title":"v2.5.2 - Changelog","doc":"* Fixes\n  * This fixes a regression on OSX where the USB gadget Ethernet would\n    incorrectly try to go into RNDIS mode and not work. Gadget Ethernet works\n    with this fix on Linux and OSX. It also works on Windows with a driver\n    installed. See the README.md for details.\n  * The USB driver uses PIO mode again. It had mistakenly been switched to DMA\n    mode. DMA mode works for a lot of USB devices, but not all and it's not what\n    Debian does. See [PR\n    138](https://github.com/nerves-project/nerves_system_bbb/pull/138) for more\n    information.\n\n* Updated dependencies\n  * [nerves_system_br v1.10.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.10.2)\n  * Erlang 22.2.4","ref":"changelog.html#v2-5-2"},{"type":"extras","title":"v2.5.1 - Changelog","doc":"This release changes the behavior of the gadget port. The gadget driver has been changed to use g_ether. This\nprovides a more stable network connection at the expense of the virtual serial\nport.\n\n* Enhancements\n  * Set `expand=true` on the application data partition. This will only take\n    effect for users running the complete task, fwup will not expand application\n    data partitions that exist during upgrade tasks.\n  * linux: swap the cdc composite gadget for g_ether\n\n* Updated dependencies\n  * [nerves_system_br v1.10.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.10.1)\n  * Erlang 22.2.3","ref":"changelog.html#v2-5-1"},{"type":"extras","title":"v2.5.0 - Changelog","doc":"This release updates Buildroot to 2019.11 with security and bug fix updates\nacross Linux packages. Enables dnsd, udhcpd and ifconfig in the default\nBusybox configuration to support `vintage_net` and `vintage_net_wizard`.\nSee the `nerves_system_br` notes for details.\n\n* Updated dependencies\n  * [nerves_system_br v1.10.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.10.0)\n  * Erlang 22.1.8\n  * Linux 4.19.72 with the Beagleboard Debian kernel patches","ref":"changelog.html#v2-5-0"},{"type":"extras","title":"v2.4.2 - Changelog","doc":"This release updates Buildroot to 2019.08.2 with security and bug fix updates\nacross Linux packages. See the `nerves_system_br` notes for details.\nErlang/OTP is now at 22.1.7.\n\nThis release also enables the pinmux helper for changing the pin settings on\nthe PocketBeagle and other boards.\n\nFor example:\n\n```bash\niex> cat \"/sys/devices/platform/ocp/ocp:P2_30_pinmux/state\"\ndefault\niex> File.write(\"/sys/devices/platform/ocp/ocp:P2_30_pinmux/state\", \"spi_cs\")\n:ok\n```\n\nFor the PocketBeagle, see\nhttps://github.com/beagleboard/linux/blob/4.19/arch/arm/boot/dts/am335x-pocketbeagle.dts#L1186\n\n* Updated dependencies\n  * [nerves_system_br v1.9.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.9.5)","ref":"changelog.html#v2-4-2"},{"type":"extras","title":"v2.4.1 - Changelog","doc":"This release pulls in security and bug fix updates from `nerves_system_br`.\nErlang/OTP is now at 22.1.1.\n\n* Updated dependencies\n  * [nerves_system_br v1.9.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.9.4)\n  * bborg-overlays - update to latest to pull in device tree overlay fixes and\n    additions from upstream","ref":"changelog.html#v2-4-1"},{"type":"extras","title":"v2.4.0 - Changelog","doc":"This release updates Buildroot to 2019.08 with security and bug fix updates\nacross Linux packages. See the `nerves_system_br` notes for details.\n\n* Updated dependencies\n  * [nerves_system_br v1.9.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.9.2)\n\n* Enhancements\n  * Support a variety of USB->UART adapters so more devices work out-of-the-box","ref":"changelog.html#v2-4-0"},{"type":"extras","title":"v2.3.2 - Changelog","doc":"This release fixes an issue where the MAC address for the wired Ethernet port on\nmany BeagleBone-based boards was not being set. Unfortunately, the fix is with\nthe U-Boot bootloader configuration and this is not updated when applying\nupdates over-the-air. Fresh firmware installs will apply the fix, so if you're\nburning MicroSD cards, you're fine. It is possible to fix the wired Ethernet MAC\naddress issue in the field if necessary. Please post to our support channels if\nyou need to do this and are not sure.\n\n* Updated dependencies\n  * [nerves_system_br v1.8.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.8.5)\n  * Linux 4.19.50","ref":"changelog.html#v2-3-2"},{"type":"extras","title":"v2.3.1 - Changelog","doc":"* Enhancements\n  * Enable source-based routing in the Linux kernel to support [vintage_net](https://github.com/nerves-networking/vintage_net)\n  * Enable pstore, an in-memory buffer that can capture logs, kernel\n    oops and other information when unexpected reboots. The buffer can be\n    recovered on the next boot where it can be inspected.\n\n* Updated dependencies\n  * [nerves_system_br v1.8.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.8.4)","ref":"changelog.html#v2-3-1"},{"type":"extras","title":"v2.3.0 - Changelog","doc":"This release\n\nThis release updates Erlang to OTP 22 and gcc from version 7.3.0 to 8.3.0.\nSee the nerves_system_br and toolchain release notes for more information.\n\n* Enhancements\n  * Enable source-based routing in the Linux kernel to support [vintage_net](https://github.com/nerves-networking/vintage_net)\n\n* Updated dependencies\n  * Erlang 22.0.4\n  * [nerves_system_br v1.8.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.8.2)\n  * [nerves_toolchain_arm_unknown_linux_gnueabihf v1.2.0](https://github.com/nerves-project/toolchains/releases/tag/v1.2.0)","ref":"changelog.html#v2-3-0"},{"type":"extras","title":"v2.2.2 - Changelog","doc":"* Bux fixes\n  * Add TAR option `--no-same-owner` to fix errors when untarring artifacts as\n    the root user.\n* Updated dependencies\n  * [nerves_system_br v1.7.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.7.2)","ref":"changelog.html#v2-2-2"},{"type":"extras","title":"v2.2.1 - Changelog","doc":"* Bug fixes\n  * Re-enabled Ralink rt2800usb WiFi driver.\n\n* Improvements\n  * Bump C compiler options to `-O2` from `-Os`. This provides a small, but\n    measurable performance improvement (500ms at boot in a trivial project\n    tested on [nerves_system_rpi0](https://github.com/nerves-project/nerves_system_rpi0)).\n  * Added r8712u.ko WiFi driver.\n\n* Updated dependencies\n  * [nerves_system_br v1.7.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.7.1)","ref":"changelog.html#v2-2-1"},{"type":"extras","title":"v2.2.0 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.7.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.7.0)\n  * Erlang 21.2.7\n  * Linux 4.19.26 with the Beagleboard Debian kernel patches","ref":"changelog.html#v2-2-0"},{"type":"extras","title":"v2.1.3 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.6.8](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.6.8)\n  * Erlang 21.2.6","ref":"changelog.html#v2-1-3"},{"type":"extras","title":"v2.1.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.6.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.6.6)\n  * Erlang 21.2.4\n  * boardid 1.5.3","ref":"changelog.html#v2-1-2"},{"type":"extras","title":"v2.1.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.6.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.6.5)\n  * Erlang 21.2.2\n  * boardid 1.5.2\n  * erlinit 1.4.9\n  * OpenSSL 1.1.1a\n  * Linux 4.19.10 with the Beagleboard Debian kernel patches\n\n* Enhancements\n  * Moved boardid config from inside erlinit.config to /etc/boardid.config","ref":"changelog.html#v2-1-1"},{"type":"extras","title":"v2.1.0 - Changelog","doc":"This pulls in a pending patch in Buildroot to update the version of\nOpenSSL from 1.0.2 to 1.1.0h. This fixes what appears to be issues with\nErlang using OpenSSL engines. It also enables Erlang crypto algorithms\nsuch as ed25519 that have been added in recent Erlang releases.\n\n* Updated dependencies\n  * [nerves_system_br v1.6.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.6.1)\n  * Erlang 21.2\n* Added dependencies\n  * wpa_passphrase\n  * libp11 0.4.9","ref":"changelog.html#v2-1-0"},{"type":"extras","title":"v2.0.0 - Changelog","doc":"* Enhancements\n  * Enable `AM335X-PRU-UIO-00A0` device tree overlay for PRU support.\n    See the [README.md](https://github.com/nerves-project/nerves_system_bbb/README.md#prus) for more information.\n* Updated dependencies\n  * [nerves_system_br v1.5.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.5.3)","ref":"changelog.html#v2-0-0"},{"type":"extras","title":"v2.0.0-rc.0 - Changelog","doc":"This is a backwards incompatible update to `nerves_system_bbb`. Over-the-air\nupdates to existing devices will not work. If you're a production user of\n`nerves_system_bbb`, please consider supporting efforts to maintain a v1.4.0\nbranch.\n\nThe v2.0.0 support adds the following:\n\n1. Device tree overlays are applied by U-Boot now. Support in Nerves is nearly\n   identical to Beagleboard.org's Debian distribution. This fixes significant\n   issues in v1.4.0 and before ever since upstream moved from loading device\n   tree overlays in Linux to U-Boot.\n2. Support for automatic failback of bad new builds. If enabled, your Nerves\n   application will need to mark a software update as good (for example, it can\n   contact a server) or else the next reboot will revert.\n3. The application partition uses F2FS rather than EXT4. This noticeably\n   improves startup time on the first boot and has some less obvious advantages\n   from being a Flash-aware file system.\n4. The hardware watchdog is enabled at boot. Your application must enable\n   `heart` now.\n5. The U-Boot environment was increased in size to 128 KB. This was required for\n   the new device tree overlay support and unfortunately makes migrating devices\n   from v1.4.0 not possible without significant work.\n\n\n* Updated dependencies\n  * [nerves_system_br v1.5.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.5.2)\n  * Linux 4.18.9 + The Beagleboard Debian kernel patches\n  * Erlang 21.0.9","ref":"changelog.html#v2-0-0-rc-0"},{"type":"extras","title":"v1.4.0 - Changelog","doc":"This release contains various updates to provisioning variables and data.\n\n**Host requirements**\n\nBuilding firmware using this system requires `fwup` to be updated on your\nhost computer to at least `v1.2.5`. The target minimum version requirement\nhas not changed from `0.15.0`.\n\n**Serial numbers**\n\nDevice serial numbers are now set using `NERVES_SERIAL_NUMBER` instead of\n`SERIAL_NUMBER`. This is to reduce ambiguity on the source of the serial\nby name spacing it along side other Nerves variables. The U-Boot environment\nkey has also changed from `serial_number` to `nerves_serial_number`. The\nerlinit.config has been updated to provide backwards compatibility for setting\nthe hostname from the serial number by checking for `nerves_serial_number`\nand falling back to `serial_number`.\n\n**Custom provisioning**\n\nProvisioning data is applied at the time of calling the `fwup` task `complete`.\nThe `complete` task is executed when writing the firmware to the target disk.\nDuring this time, `fwup` will include the contents of a provisioning file\nlocated at `${NERVES_SYSTEM}/images/fwup_include/provisioning.conf`. By default,\nthis file only sets `nerves_serial_number`. You can add additional provisioning\ndata by overriding the location of this file to include your own by setting\nthe environment variable `NERVES_PROVISIONING`. If you override this variable\nyou will be responsible for also setting `nerves_serial_number`.\n\n* Updated dependencies\n  * [nerves_system_br v1.4.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.4.5)","ref":"changelog.html#v1-4-0"},{"type":"extras","title":"v1.3.0 - Changelog","doc":"This release upgrades gcc from version 6.3.0 to 7.3.0. See the toolchain release\nnotes for more information.\n\nSwitch to using busybox.fragment for easier maintainance.\n\n* Updated dependencies\n  * [nerves_system_br v1.4.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.4.1)\n  * [nerves_toolchain_arm_unknown_linux_gnueabihf v1.1.0](https://github.com/nerves-project/toolchains/releases/tag/v1.1.0)","ref":"changelog.html#v1-3-0"},{"type":"extras","title":"v1.2.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.3.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.3.2)","ref":"changelog.html#v1-2-1"},{"type":"extras","title":"v1.2.0 - Changelog","doc":"This release updates Erlang to OTP 21.0\n\n* Updated dependencies\n  * [nerves_system_br v1.3.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.3.0)","ref":"changelog.html#v1-2-0"},{"type":"extras","title":"v1.1.1 - Changelog","doc":"This release fixes some issues and adds firmware UUID support. This support can\nbe used to unambiguously know what's running on a device.\n\n* Updated dependencies\n  * [nerves_system_br v1.2.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.2.2)\n\n* Bug fixes\n  * Empty serial numbers stored in the U-Boot environment would be used instead\n    of reverting to devices IDs built into the CPU or board.\n  * It wasn't possible to enable QtWebEngine (needed for kiosk apps)","ref":"changelog.html#v1-1-1"},{"type":"extras","title":"v1.1.0 - Changelog","doc":"This release adds official support for provisioning serial numbers to devices.\nOther information can be provisioned in a similar manner. See the README.md for\ndetails.\n\nBuildroot was also updated to 2018.05. Be sure to review the `nerves_system_br`\nlink for the changes in the embedded Linux components.\n\n* Updated dependencies\n  * [nerves_system_br v1.2.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.2.0)\n\n* New features\n  * More `wpa-supplicant` features were enabled to support more WiFi use-cases","ref":"changelog.html#v1-1-0"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"This release is nearly identical to rc.1 except with the deps bump to 1.0 and\ndocumentation/comment updates.\n\n* Updated dependencies\n  * [nerves_system_br v1.0.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.0.0)\n  * [nerves_toolchain v1.0.0](https://github.com/nerves-project/toolchains/releases/tag/v1.0.0)\n  * [nerves v1.0.0](https://github.com/nerves-project/nerves/releases/tag/1.0.0)","ref":"changelog.html#v1-0-0"},{"type":"extras","title":"v1.0.0-rc.1 - Changelog","doc":"This release contains updates to Erlang and heart from `nerves_system_br`. It\nalso has a configuration change to the Linux kernel that enables scaling the\nprocessor frequency based on workload. This makes the process run much cooler\nwhile still allowing it to increase frequency for heavy computations.\n\nNote that the trivial `.fw` files are no longer created by CI scripts. If you've\nforked this project and are building systems using CI, make sure to update your\npublish scripts.\n\n* Updated dependencies\n  * [nerves_system_br v1.0.0-rc.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.0.0-rc.2)\n  * Linux 4.4.113 w/ RCN's patches","ref":"changelog.html#v1-0-0-rc-1"},{"type":"extras","title":"v1.0.0-rc.0 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.0.0-rc.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.0.0-rc.0)\n  * [nerves_toolchain v1.0.0-rc.0](https://github.com/nerves-project/toolchains/releases/tag/v1.0.0-rc.0)\n  * [nerves v1.0.0-rc.0](https://github.com/nerves-project/nerves/releases/tag/1.0.0-rc.0)","ref":"changelog.html#v1-0-0-rc-0"},{"type":"extras","title":"v0.20.0 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v0.17.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.17.0)\n  * [nerves_toolchain v0.13.0](https://github.com/nerves-project/toolchains/releases/tag/v0.13.0)\n  * [nerves v0.9.0](https://github.com/nerves-project/nerves/releases/tag/v0.9.0)","ref":"changelog.html#v0-20-0"},{"type":"extras","title":"v0.19.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v0.16.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.16.3)\n    This fixes the call to otp_build so that it always uses Buildroot's version\n    the autoconf tools.","ref":"changelog.html#v0-19-1"},{"type":"extras","title":"v0.19.0 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v0.16.1-2017-11](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.16.1-2017-11)\n\n* Enhancements\n  * Reboot automatically if Erlang VM exits - This is consistent with other\n    Nerves systems. See rootfs_overlay/etc/erlinit.config if undesired.\n  * Start running nerves_system_linter to check for configuration errors.\n  * Automount the boot partition readonly at `/boot`\n  * Support for reverting firmware.\n\n    See [Reverting Firmware](https://hexdocs.pm/nerves_runtime/readme.html#reverting-firmware) for more info on reverting firmware.\n\n    See [fwup-revert.conf](https://github.com/nerves-project/nerves_system_rpi/blob/master/fwup-revert.conf) for more information on how fwup handles reverting.","ref":"changelog.html#v0-19-0"},{"type":"extras","title":"v0.18.0 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v0.15.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.15.0)\n  * [toolchain v0.12.1](https://github.com/nerves-project/toolchains/releases/tag/v0.12.1)\n  * u-boot 2017.09\n  * Linux 4.4.91 w/ RCN's patches\n\n* Enhancements\n  * Support for nerves 0.8. Moves nerves.exs into mix.exs\n  * Support for pocketbeagle\n\n* Bug Fixes\n  * Clear out the wl18xx MAC address field\n    This will trigger the WiLink device driver to use the MAC address that\n    TI programmed into the module rather than 00:00:de:ad:be:ef.","ref":"changelog.html#v0-18-0"},{"type":"extras","title":"v0.17.1 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v0.14.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.14.1)","ref":"changelog.html#v0-17-1"},{"type":"extras","title":"v0.17.0 - Changelog","doc":"This release changes the default IEx prompt output from the debug UART pins\nto a virtual serial port on the USB OTG connector. This release also enables\na virtual Ethernet interface on the same USB interface for software updates.\nSee the `nerves_init_gadget` project for initialization code.\n\n* Updated dependencies\n  * [nerves_system_br v0.14.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v0.14.0)\n    * [Buildroot 2017.08](https://git.busybox.net/buildroot/plain/CHANGES?id=2017.08)\n    * [fwup 0.17.0](https://github.com/fhunleth/fwup/releases/tag/v0.17.0)\n    * [erlinit 1.2.0](https://github.com/nerves-project/erlinit/releases/tag/v1.2.0)\n    * [nbtty 0.3.0](https://github.com/fhunleth/nbtty/releases/tag/v0.3.0)\n\n* Enhancements\n  * Add global patch directory\n\n  This is required to pull in the e2fsprogs patch that's needed now that\n  util-linux's uuid_generate function calls getrandom and can block\n  indefinitely for the urandom pool to initialize\n\n* Bug Fixes\n  * Use `nbtty` by default to fix tty hang issue","ref":"changelog.html#v0-17-0"},{"type":"extras","title":"v0.16.1 - Changelog","doc":"* Updated dependencies\n  * nerves_system_br v0.13.7","ref":"changelog.html#v0-16-1"},{"type":"extras","title":"v0.16.0 - Changelog","doc":"This release contains an updated toolchain with Linux 4.1 Headers.\nYou will have to clean and compile any c/c++ code in your project and\ndependencies. Failure to do so will result in an error when producing firmware.\n\n* nerves_system_br v0.13.5\n  * fwup 0.15.4\n\n* Nerves toolchain v0.11.0","ref":"changelog.html#v0-16-0"},{"type":"extras","title":"v0.15.0 - Changelog","doc":"* nerves_system_br v0.13.3\n  * erlinit 1.1.4\n\n* New features\n  * Firmware updates verify that they're updating the right target. If the target\n    doesn't say that it's an `bbb` through the firmware metadata, the update\n    will fail.\n  * Added meta-misc and meta-vcs-identifier to the `fwup.conf` metadata for use\n    by users and for the regression test framework\n  * Use String.trim instead of String.strip to silence Elixir 1.5 warnings","ref":"changelog.html#v0-15-0"},{"type":"extras","title":"v0.14.0 - Changelog","doc":"* nerves_system_br v0.13.2\n  * OTP 20\n  * erlinit 1.1.3\n  * fwup 0.15.3","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"v0.13.0 - Changelog","doc":"This release is NOT backwards compatible with previous releases and will not\nupgrade old systems. With work, it is possible to upgrade old systems, but it is\nnot recommended.\n\n* nerves_system_br v0.12.1\n  * erlinit 1.1.1\n  * fwup 0.15.0\n\n* New features\n  * The application data partition is now `ext4`. This greatly improves its\n    robustness to corruption. Nerves.Runtime contains code to initialize it on\n    first boot.\n  * Firmware images now contain metadata that can be queried at runtime (see\n    Nerves.Runtime.KV\n  * The boot partition is managed in an A/B style to support more robust\n    firmware updates.\n\n* Bug fixes\n  * The Linux kernel is no longer compiled for SMP. All Beaglebone variants\n    are single processor.\n\nNOTE: It is possible to support \"failback\" operation of firmware updates with\nthe BBB. I.e. if an partition doesn't boot, the system reverts to the previous\none. This is not implemented here, but this system is being made to align more\nwith implementations that do this to make the transition easier.","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"v0.12.0 - Changelog","doc":"* nerves_system_br v0.10.0\n  * Buildroot 2017.02\n  * Erlang/OTP 19.3\n\n* New features\n  * Support for BBG Wireless - the BBGW's MAC Address is not automatically set\n    so support needs to be added. However, one BBGW on a WLAN works.\n  * Bump Linux kernel to 4.4.60","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"v0.11.0 - Changelog","doc":"* New Features\n  * Support for Nerves 0.5.0","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"v0.10.0 - Changelog","doc":"* New features\n  * Bump toolchain to use gcc 5.3 (previously using gcc 4.9.3)\n  * Bump Linux kernel to 4.4.43","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"This version switches to using the `nerves_package` compiler. This will\nconsolidate overall deps and compilers.\n\n* Nerves.System.BR v0.8.1\n  * Support for distillery\n  * Support for nerves_package compiler","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"When upgrading to this version, be sure to review the updates to\nnerves_defconfig. BR2_PACKAGE_ERLANG is no longer selected automatically and\nmust be added.\n\n* nerves_system_br v0.7.0\n  * Package updates\n    * Buildroot 2016.08\n\n  * Bug fixes\n    * Many packages were removed. These include Elixir and LFE since neither are\n      actually used. Both are added as part of the user build step, so no\n      functionality is lost. The most visible result is that the system images\n      are smaller and the test .fw file boots to the Erlang prompt.\n    * Fix false positive from scrubber when checking executable formats due to\n      C++ template instantiations. Ignores SYSV vs. GNU/Linux ABI difference.","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"* Package versions\n  * Nerves.System.BR v0.6.1\n\n* New features\n  * Pull in BeagleBone Green updates (new u-boot, bbg device tree)","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"* Nerves.System.BR v0.6.0\n  * Package updates\n    * Erlang OTP 19\n    * Elixir 1.3.1\n    * fwup 0.8.0\n    * erlinit 0.7.3\n    * bborg-overlays (pull in I2C typo fix from upstream)\n  * Bug fixes\n    * Synchronize file system kernel configs across all platforms","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.2 - Changelog","doc":"* Bug Fixes\n  * Enabled bbborg-overlays for universal device tree","ref":"changelog.html#v0-6-2"},{"type":"extras","title":"v0.6.1 - Changelog","doc":"* Nerves.System.BR v0.5.1\n  * Bug Fixes(nerves-env)\n    * Added include paths to CFLAGS and CXXFLAGS\n    * Pass sysroot to LDFLAGS","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"* Nerves.System.BR v0.5.0\n  * New features\n    * WiFi drivers enabled by default on RPi2 and RPi3\n    * Include wireless regulatory database in Linux kernel by default\n      on WiFi-enabled platforms. Since kernel/rootfs are read-only and\n      coupled together for firmware updates, the normal CRDA/udev approach\n      isn't necessary.\n    * Upgraded the default BeagleBone Black kernel from 3.8 to 4.4.9. The\n      standard BBB device tree overlays are included by default even though the\n      upstream kernel patches no longer include them.\n    * Change all fwup configurations from two step upgrades to one step\n      upgrades. If you used the base fwup.conf files to upgrade, you no\n      longer need to finalize the upgrade. If not, there's no change.","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"* Nerves.System.BR v0.4.1\n  * Bug fixes\n    * syslinux fails to boot when compiled on some gcc 5 systems\n    * Fixed regression when booting off eMMC on the BBB\n\n  * Package updates\n    * Erlang 18.3\n    * Elixir 1.2.5\n* Enhancements\n  * Includes config-pin for controlling pin muxing. See [beaglebone-universal-io](https://github.com/cdsteinkuehler/beaglebone-universal-io)","ref":"changelog.html#v0-5-0"}],"content_type":"text/markdown"}